﻿using Microsoft.AspNetCore.SignalR;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace ProRestaurant.Models.Restaurants
{
    public class Restaurant : BaseObject
    {
        public string Name { get; set; }
        public string Location { get; set; } //Set with google's autocomplete(suburb)
        public string Logo { get; set; }
        public bool Chain { get; set; } //if no, do not display the location on card
        public decimal DeliveryFee { get; set; }
        public decimal DeliveryRadius { get; set; }
        public string MethodsOfPayment { get; set; } //Comma separated list - can be displayed as a drop down. 
        public ICollection<TradingHours> TradingHours { get; set; }
    }
}
